#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# packagesync.py - sync installed packages across several computers.
#
# Copyright 2010 Duane Hinnen
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
#
''' 
Establish connection with the CouchDB
http://arstechnica.com/open-source/guides/2009/12/code-tutorial-make-your-application-sync-with-ubuntu-one.ars
http://www.kryogenix.org/days/2010/01/26/adding-ubuntu-one-support-to-your-applications-an-irc-lecture
'''

from desktopcouch.records.server import CouchDatabase
from desktopcouch.records.record import Record as CouchRecord

database = CouchDatabase("packages", create=True)
databaserecord = ""
RECORD_TYPE = 'http://www.okiebuntu.homelinux.com/packagesync'


class Database(object):
    def __init__(self):
        pass

    def saveData(self, _id, key, data):    
        record_one = CouchRecord({  "_id"      : _id       ,
                                    "profile"  : "user001" ,
                                    key        : data      ,
                                }, record_type = RECORD_TYPE)
        databaserecord = database.put_record(record_one)
        return databaserecord

    def restoreData(_id):
        map_js2 = 'function(doc){if (doc._id == ' + _id + '){emit(null,doc.file);}}'
        database.add_view("vimconfig", map_js2, None, "getfile")
        result = database.execute_view("vimconfig", "getfile")
        
        for row in result:
            config_iter = row.value

        return config_iter
        
if __name__ == "__main__":
    print __doc__
