#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# packagesync.py - sync installed packages across several computers.
#
# Copyright 2010 Duane Hinnen
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
#
'''
Main Program
Uses Ubuntu-one to sync different stuff
https://wiki.ubuntu.com/OneConf
'''
import os
import commands
from core.gui import Window
from desktopcouch.records.server import CouchDatabase

database = CouchDatabase("packages", create=True)

class Stipple(object):
    def UseSettings(self):
        '''
        Create a View. Execute view. Iterate over it.
        Write the package selections to a tmp file.
        Use file to set selections and then intall the packages
        '''
        map_js = 'function(doc){if (doc._id == "deb"){emit(null,doc.packages);}}'
        database.add_view("installed", map_js, None, "getnames")
        result = database.execute_view("installed", "getnames")

        for row in result:
            dpkglist = row.value
        
        tmp_file = open('/tmp/workfile', 'w')
        tmp_file.write(dpkglist)
        os.system ("sudo dpkg --set-selections < /tmp/workfile")
        os.system ("sudo apt-get -y update")
        os.system ("sudo apt-get dselect-upgrade")
        tmp_file.close()


    def UseConfig(self):
        '''
        Create a View. Execute view. Iterate over it.
        Write the data to a .config in users ~/
        '''
    #    config_iter = ""
    ### emacs ###
        map_js2 = 'function(doc){if (doc._id == "emacs"){emit(null,doc.file);}}'
        database.add_view("emacsconfig", map_js2, None, "getfile")
        result = database.execute_view("emacsconfig", "getfile")

        for row in result:
            config_iter = row.value
            print config_iter
        emacs_file = open(os.path.expanduser("~") + "/.emacs2", 'w')
        emacs_file.write(config_iter)
        emacs_file.close()

    ### vim ####
        map_js2 = 'function(doc){if (doc._id == "vim"){emit(null,doc.file);}}'
        database.add_view("vimconfig", map_js2, None, "getfile")
        result = database.execute_view("vimconfig", "getfile")

        for row in result:
            config_iter = row.value

        vim_file = open(os.path.expanduser("~") + "/.vimrc2", 'w')
        vim_file.write(config_iter)
        vim_file.close()

    ### bash ####
        map_js2 = 'function(doc){if (doc._id == "bash"){emit(null,doc.file);}}'
        database.add_view("bashconfig", map_js2, None, "getfile")
        result = database.execute_view("bashconfig", "getfile")

        for row in result:
            config_iter = row.value

        bash_file = open(os.path.expanduser("~") + "/.bashrc2", 'w')
        bash_file.write(config_iter)
        bash_file.close()

    ### zsh ####
        map_js2 = 'function(doc){if (doc._id == "zsh"){emit(null,doc.file);}}'
        database.add_view("zshconfig", map_js2, None, "getfile")
        result = database.execute_view("zshconfig", "getfile")

        for row in result:
            config_iter = row.value

        zsh_file = open(os.path.expanduser("~") + "/.zshrc2", 'w')
        zsh_file.write(config_iter)
        zsh_file.close()   


def run():
    window = Window()
    window.main()

if __name__ == "__main__":
    print __doc__
