#!/usr/bin/env python
#
# packagesync.py - sync installed packages across several computers.
#
# Copyright 2010 Duane Hinnen
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import tempfile
import sys
import os

import pygtk
pygtk.require('2.0')
import gtk

from desktopcouch.records.server import CouchDatabase
from desktopcouch.records.record import Record as CouchRecord
import commands

database = CouchDatabase("packages", create=True)
databaserecord = ""
RECORD_TYPE = 'http://www.okiebuntu.homelinux.com/packagesync'
EMACS_CONFIG = os.path.expanduser("~") + "/.emacs"
VIM_CONFIG = os.path.expanduser("~") + "/.vimrc"
ZSH_CONFIG = os.path.expanduser("~") + "/.zshrc"
BASH_CONFIG = os.path.expanduser("~") + "/.bashrc"
a = 0
b = 0
c = 0
d = 0

class Window:

    def callback1(self, widget, data=None):
       # print "%s was toggled %s" % (data, ("OFF", "ON")[widget.get_active()])
        a = (1, 2)[widget.get_active()]
        print a
    def callback2(self, widget, data=None):
        b = (1, 2)[widget.get_active()]
        print b
    def callback3(self, widget, data=None):
        c = (1, 2)[widget.get_active()]
        print c
    def callback4(self, widget, data=None):
        d = (1, 2)[widget.get_active()]
        print d

    def run(self, widget, data=None):
        print "hello"
        save = Save()
        restore = Restore()
        if a == 2:
            print "making database1"
            save.makeDB()
        if b == 2:
            print "making database2"
            save.search()
        if c == 2:
            print "making database3"
            restore.UseSettings()
        if d == 2:
            print "making database4"
            restore.UseConfig()
        else:
            pass


    def delete_event(self, widget, event, data=None):
        gtk.main_quit()
        return False
        
    def __init__(self):
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event", self.delete_event)
        self.window.set_border_width(20)
        vbox = gtk.VBox(True, 2)
        self.window.add(vbox)
        ## 1st Button ##
        button = gtk.CheckButton("sync packages")
        button.connect("toggled", self.callback1, "sync packages")
        vbox.pack_start(button, True, True, 0)
        button.show()
        ## 2nd Button ##
        button = gtk.CheckButton("sync config files")
        button.connect("toggled", self.callback2, "sync config files")
        vbox.pack_start(button, True, True, 0)
        button.show()
        ## 3rd Button ##
        button = gtk.CheckButton("restore packages")
        button.connect("toggled", self.callback3, "restore packages")
        vbox.pack_start(button, True, True, 0)
        button.show()
        ## 4th Button ##
        button = gtk.CheckButton("restore config files")
        button.connect("toggled", self.callback4, "restore config files")
        vbox.pack_start(button, True, True, 0)
        button.show()
        
        ##Run Command Button ##
        button = gtk.Button("Run")
        button.connect("clicked", self.run)
        vbox.pack_start(button, True, True, 0)
        button.show()
        ## Quit Button ##
        button = gtk.Button("Quit")
        button.connect("clicked", lambda wid: gtk.main_quit())
        vbox.pack_start(button, True, True, 2)
        button.show()


        vbox.show()
        self.window.show()

    def main(self):
        gtk.main()

class Save:
    def makeDB(self):
        '''
        gets list of package selections. Cleans up the output.
        saves the data to a CouchDB.
        '''

        getsel_unfor = commands.getoutput("dpkg --get-selections '*'")
        getsel = getsel_unfor.replace("\t"," ") #.replace("\n"," ")
        
        record_one = CouchRecord({  "_id"       :  "deb"     ,
                                    "profile"   :  "user001" ,
                                    "packages"  :  getsel    ,
                                  },
                                  record_type = RECORD_TYPE)

        databaserecord = database.put_record(record_one)


    def search(self):
        search_string = commands.getoutput("dpkg --get-selections '*'")
        if search_string.find("emacs") != -1:
                with open(EMACS_CONFIG, 'r') as emacs:
                    er = emacs.read()
                print er


                record_two = CouchRecord({  "_id"       :  "emacs"   ,  
                                            "profile"   :  "user001" ,
                                            "type"      :  "dotfile" ,
                                            "file"      :  er        ,
                                         },
                                         record_type = RECORD_TYPE)

                databaserecord = database.put_record(record_two)
                emacs.close()

        if search_string.find("vim") != -1:
                with open(VIM_CONFIG, 'r') as vim:
                    vr = vim.read()
                print vr


                record_two = CouchRecord({  "_id"       :  "vim"   ,  
                                            "profile"   :  "user001" ,
                                            "type"      :  "dotfile" ,
                                            "file"      :  vr        ,
                                         },
                                         record_type = RECORD_TYPE)

                databaserecord = database.put_record(record_two)
                vim.close()


        if search_string.find("zsh") != -1:
                with open(ZSH_CONFIG, 'r') as zsh:
                    zr = zsh.read()
                print zr


                record_two = CouchRecord({  "_id"       :  "zsh"   ,  
                                            "profile"   :  "user001" ,
                                            "type"      :  "dotfile" ,
                                            "file"      :  zr        ,
                                         },
                                         record_type = RECORD_TYPE)

                databaserecord = database.put_record(record_two)
                zsh.close()


        if search_string.find("bash") != -1:
                with open(BASH_CONFIG, 'r') as bash:
                    br = bash.read()
                print br


                record_two = CouchRecord({  "_id"       :  "bash"   ,  
                                            "profile"   :  "user001" ,
                                            "type"      :  "dotfile" ,
                                            "file"      :  br        ,
                                         },
                                         record_type = RECORD_TYPE)

                databaserecord = database.put_record(record_two)
                bash.close()
        else:
                pass

        
class Restore:
    def UseSettings(self):
        '''
        Create a View. Execute view. Iterate over it.
        Write the package selections to a tmp file.
        Use file to set selections and then intall the packages
        '''
        print "setting"
        map_js = 'function(doc){if (doc._id == "deb"){emit(null,doc.packages);}}'
        database.add_view("installed", map_js, None, "getnames")
        result = database.execute_view("installed", "getnames")

        for row in result:
            dpkglist = row.value
        
        tmp_file = open('/tmp/workfile', 'w')
        tmp_file.write(dpkglist)
        os.system ("sudo dpkg --set-selections < /tmp/workfile")
        os.system ("sudo apt-get -y update")
        os.system ("sudo apt-get dselect-upgrade")
        tmp_file.close()


    def UseConfig(self):
        '''
        Create a View. Execute view. Iterate over it.
        Write the data to a .config in users ~/
        '''
        print "config"
        #    config_iter = ""
        ### emacs ###
        map_js2 = 'function(doc){if (doc._id == "emacs"){emit(null,doc.file);}}'
        database.add_view("emacsconfig", map_js2, None, "getfile")
        result = database.execute_view("emacsconfig", "getfile")

        for row in result:
            config_iter = row.value
            print config_iter
        emacs_file = open(os.path.expanduser("~") + "/.emacs2", 'w')
        emacs_file.write(config_iter)
        emacs_file.close()
        ### vim ####
        map_js2 = 'function(doc){if (doc._id == "vim"){emit(null,doc.file);}}'
        database.add_view("vimconfig", map_js2, None, "getfile")
        result = database.execute_view("vimconfig", "getfile")

        for row in result:
            config_iter = row.value

        vim_file = open(os.path.expanduser("~") + "/.vimrc2", 'w')
        vim_file.write(config_iter)
        vim_file.close()
         ### bash ####
        map_js2 = 'function(doc){if (doc._id == "bash"){emit(null,doc.file);}}'
        database.add_view("bashconfig", map_js2, None, "getfile")
        result = database.execute_view("bashconfig", "getfile")

        for row in result:
            config_iter = row.value

        bash_file = open(os.path.expanduser("~") + "/.bashrc2", 'w')
        bash_file.write(config_iter)
        bash_file.close()
         ### zsh ####
        map_js2 = 'function(doc){if (doc._id == "zsh"){emit(null,doc.file);}}'
        database.add_view("zshconfig", map_js2, None, "getfile")
        result = database.execute_view("zshconfig", "getfile")

        for row in result:
            config_iter = row.value

        zsh_file = open(os.path.expanduser("~") + "/.zshrc2", 'w')
        zsh_file.write(config_iter)
        zsh_file.close()   


if __name__ == "__main__":
    window = Window()
    window.main()
    '''sr = raw_input("Do you want to save or restore? (s/r): ")
    if sr == "s":
        makeDB()
    elif sr == "r":
        #UseSettings()
        UseConfig()
    else:
        print "please type 's' or 'r'"
    print "finished"   '''
