#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# packagesync.py - sync installed packages across several computers.
#
# Copyright 2010 Duane Hinnen
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import os
from core.stipple import PluginBase

HOME_DIR = os.path.expanduser("~")
BAZAAR_IGNORE = HOME_DIR + "/.bazaar/ignore"

class Plugin(PluginBase):
    """
    It's blah
    """
    def __init__(self):
        self.name = "Bazaar-ignore"
        self.prog_name = "bzr"
        self.record_name = self.name.lower()    
    
    def sync(self):
        """It must be installed"""
        with open(BAZAAR_IGNORE, "r") as ignore:
            ig = ignore.read()
        ignore.close()
        self.saveDotFile(ig)
        return True
    
    def restore(self):
        self.recoverDotFile(BAZAAR_IGNORE)
        return True