#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# packagesync.py - sync installed packages across several computers.
#
# Copyright 2010 Duane Hinnen, Marcos Vanetta
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import os

from core.stipple import PluginBase
HOME_DIR = os.path.expanduser("~")
COMPIZ_DIR = HOME_DIR + ".compiz"

class Plugin(PluginBase):
    """
    Compiz manager sync
    """
    def __init__(self):
        self.name = "Compiz options"
        self.prog_name = "compiz"
    
    def sync(self):
        self.attachDirectory(COMPIZ_DIR)
        return True
    
    def restore(self):
        self.recoverDirectory(COMPIZ_DIR)
        return True