#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# packagesync.py - sync installed packages across several computers.
#
# Copyright 2010 Duane Hinnen, Marcos Vanetta
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import os
from core.stipple import PluginBase
HOME_DIR = os.path.expanduser("~")
VIM_CONFIG = HOME_DIR + "/.vimrc"
VIM_DIR = HOME_DIR + "/.vim"
class Plugin(PluginBase):
    """
    It's blah
    """
    def __init__(self):
        self.name = "Vim"
        self.prog_name = "vim"
        self.record_name = self.name.lower()    
    
    def sync(self):
        """It must be installed"""
        with open(VIM_CONFIG, "r") as vim:
            vr = vim.read()
        vim.close()
        self.saveDotFile(vr)
        self.attachDirectory(VIM_DIR)
        return True
    
    def restore(self):
        cad = self.recoverDotFile()
        if cad:
            with open(VIM_CONFIG) as vim:
                vim.write(cad)
            vim.close()    
        self.recoverDirectory(VIM_DIR)
        return True